Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/derby/DerbySQLServer.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/derby/DerbySQLServer.java	(revision 15191)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/sql/derby/DerbySQLServer.java	(revision 15191)
@@ -0,0 +1,70 @@
+package org.greenstone.gsdl3.sql.derby;
+
+
+import org.apache.log4j.*;
+import org.greenstone.gsdl3.sql.*;
+import java.sql.Connection;
+import java.sql.DriverManager;
+import java.sql.SQLException;
+
+public class DerbySQLServer implements SQLServer{
+    static final String PROTOCOL = "jdbc:derby:";
+    static final String DRIVER = "org.apache.derby.jdbc.EmbeddedDriver";
+    static Logger logger = Logger.getLogger(org.greenstone.gsdl3.sql.derby.DerbySQLServer.class.getName());     
+
+    public DerbySQLServer(){
+	try{
+	    Class.forName(DRIVER).newInstance();
+	}
+        catch(Exception e){
+	    logger.error("Couldn't find derby driver: "+DRIVER,e);
+	}
+    }
+
+    public Connection connect(String databasePath){
+	try{
+	    String  protocol_str = PROTOCOL + databasePath; 
+	    Connection connection = DriverManager.getConnection(protocol_str);
+	    return connection;
+	}
+        catch(Exception e){
+	    logger.info("Connect to database "+databasePath + " failed!");
+	}
+
+	return null;
+	
+    }
+
+    public Connection connectAndCreate(String databasePath){
+	try{
+	    String  protocol_str = PROTOCOL + databasePath + ";create=true"; 
+	    Connection connection = DriverManager.getConnection(protocol_str);
+	    return connection;
+	}
+	catch(Exception e){
+	    logger.error("Connect to database "+databasePath + " failed!",e);
+	
+	}
+	return null;
+    } 
+
+    public boolean disconnect(String databasePath){
+	try{
+	    String protocol_str = PROTOCOL + databasePath + ";shutdown=true"; 
+	    DriverManager.getConnection(protocol_str);
+	}catch (SQLException se){
+	    String theError = (se).getSQLState();
+	    if (!theError.equals("08006")){
+		logger.error("Database "+databasePath + " couldn't be shut down properly!",se);
+	    }
+	    else{
+		return true;
+	    }
+	}
+	
+	return false;
+    }
+
+
+   
+}
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GDBMWrapper.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GDBMWrapper.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GDBMWrapper.java	(revision 15191)
@@ -52,5 +52,5 @@
     }
 
-    /** cloase the database associated with this wrapper */
+    /** close the database associated with this wrapper */
     public void closeDatabase() {
 	try {
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSFile.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSFile.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSFile.java	(revision 15191)
@@ -291,4 +291,8 @@
     /** the gdbm database file - 
      * note, need to change extension depending on OS */
+    // The perl code can't detect big vs little endian on a Mac, so the Perl
+    // code will always name the gdbm db file .bdb on a Mac whether its little
+    // endian or not. A Mac little endian file is NOT the same as a Linux 
+    // little endian file
     static public String GDBMDatabaseFile(String site_home, 
 					  String collection_name,
@@ -296,5 +300,5 @@
 
 	String db_ext = ".ldb";
-	if (Misc.isBigEndian()) {
+	if (Misc.isMac() || Misc.isBigEndian()) {
 	    db_ext = ".bdb";
 	}
Index: /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java
===================================================================
--- /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/src/java/org/greenstone/gsdl3/util/GSXML.java	(revision 15191)
@@ -694,4 +694,22 @@
     return null;
   }
+  /** returns a NodeList of elements: ancestor/node_name[@attribute_name='attribute_value']
+   */
+  public static NodeList getNamedElements(Element ancestor, String node_name, String attribute_name, String attribute_value) {
+	    MyNodeList node_list = new MyNodeList();
+	    NodeList children = ancestor.getElementsByTagName(node_name);
+	    
+		if(children != null && children.getLength() > 0) {
+			
+			for (int i=0; i<children.getLength(); i++) {
+				Node child = children.item(i);
+				if (child.getNodeName().equals(node_name)) {
+					if (((Element)child).getAttribute(attribute_name).equals(attribute_value))
+						node_list.addNode(child);
+				}			
+			}			
+	    }
+	    return node_list;
+  }
   
   public static int SORT_TYPE_STRING = 0;
Index: /greenstone3/branches/customizingGreenstone3/web/interfaces/classic/transform/pref.xsl
===================================================================
--- /greenstone3/branches/customizingGreenstone3/web/interfaces/classic/transform/pref.xsl	(revision 15190)
+++ /greenstone3/branches/customizingGreenstone3/web/interfaces/classic/transform/pref.xsl	(revision 15191)
@@ -204,5 +204,5 @@
     <xsl:param name="prefix"/>
     
-    <xsl:if test="not(@name='matchMode') and not(@name='level') and not(@name='index') and not(@name='sortBy') and (@type='boolean' or @type='enum_single')"><xsl:apply-templates select="." mode="radio"><xsl:with-param name="display" select="$display"/><xsl:with-param name="prefix" select="$prefix"/><xsl:with-param name="paramIdx" select="position()"/></xsl:apply-templates></xsl:if>    
+    <xsl:if test="not(@name='matchMode') and not(@name='level') and not(@name='index') and not(@name='sortBy') and not(@name='indexSubcollection') and not(@name='indexLanguage') and (@type='boolean' or @type='enum_single')"><xsl:apply-templates select="." mode="radio"><xsl:with-param name="display" select="$display"/><xsl:with-param name="prefix" select="$prefix"/><xsl:with-param name="paramIdx" select="position()"/></xsl:apply-templates></xsl:if>    
   </xsl:template>
   
@@ -224,5 +224,5 @@
       <tr><xsl:attribute name="id"><xsl:value-of select="concat($prefix, '-', $paramIdx, '-', position())"/></xsl:attribute><xsl:if test="$display='n'"><xsl:attribute name="style">display:none</xsl:attribute></xsl:if>
       <xsl:if test="position()=1"><td rowspan='{$numOptions}' valign='baseline'><xsl:value-of select="../displayItem"/></td></xsl:if>
-      <td><input type='radio' name='{$cachedName}' value="{$value}"><xsl:if test="$cachedValue=$value"><xsl:attribute name="checked"></xsl:attribute></xsl:if></input></td>
+      <td><input type='radio' name='{$cachedName}' value="{$value}"><xsl:if test="$cachedValue=$value"><xsl:attribute name="checked">true</xsl:attribute></xsl:if></input></td>
       <td><xsl:value-of select="displayItem"/></td>
       </tr>
